@rem = '--*-Perl-*--
@echo off
if "%OS%" == "Windows_NT" goto WinNT
perl -x -S "%0" %1 %2 %3 %4 %5 %6 %7 %8 %9
goto endofperl
:WinNT
perl -x -S %0 %*
if NOT "%COMSPEC%" == "%SystemRoot%\system32\cmd.exe" goto endofperl
if %errorlevel% == 9009 echo You do not have Perl in your PATH.
if errorlevel 1 goto script_failed_so_exit_with_non_zero_val 2>nul
goto endofperl
@rem ';
#!/usr/bin/perl
#line 15

=head1 NAME

oai-listsets - list sets in an OAI-PMH archive

=head1 SYNOPSIS

    oai-listsets --baseURL=http://preprint.chemweb.com/CPS/OAI

=head1 DESCRIPTION

A command line utility to listing the sets that belong to an OAI-PMH 
archive.

=head1 AUTHORS

=over 4 

=item * Ed Summers <ehs@pobox.com>

=back

=cut

use strict;
use Getopt::Long;
use Net::OAI::Harvester;
use Pod::Usage;

my ( $url, $debug ); 

GetOptions(
    'baseURL:s'	=> \$url,
    'debug!'	=> \$debug,
);

if ( !$url ) { 
    pod2usage( { -verbose => 0 } );
}

my $harvester = Net::OAI::Harvester->new( baseURL => $url );
$Net::OAI::Harvester::DEBUG = 1 if $debug;

my $list = $harvester->listSets();

if ( $list->errorCode() ) { 
    print STDERR $list->errorString(); 
    exit(1);
}

foreach my $spec ( $list->setSpecs() ) { 
    my $name = $list->setName( $spec );
    print "$spec ==> $name\n";
}

__END__
:endofperl
